#include <stdio.h>
#include <stdlib.h>
#include "count.h"
#include "utils.h"

static int **edges;
static int n;
static struct permlist_node *perms;
static struct permlist_node *pl;
int *facts;

void put1First(int, int *);
void printArray(int, int *);
int count_configs(void);

int main(int argc, char *argv[]){
  int e,i,n1,n2,f;
  FILE *fp = fopen(argv[1], "r");
  struct permlist_node *pln;
  
  /* get number of nodes and number of edges */
  fscanf(fp, "%d %d\n", &n, &e);

  /* allocate space for adjacency list */
  edges = malloc((n+1) * sizeof(int *));
  for(i=0; i<=n; i++){
    edges[i] = calloc(n+1, sizeof(int));
  }
  facts = malloc((n+1)*sizeof(int));
  facts[0] = 1;
  for(i = 1; i<=n; i++){
    facts[i] = i*facts[i-1];
  }
  /* read in adjancy list */
  for(i = 0; i<e; i++){
    fscanf(fp, "%d %d\n", &n1, &n2);
    edges[n1][n2] = edges[n2][n1] = 1;
  }

  fclose(fp);

  f = facts[n-1];
  perms = malloc((f+1) * sizeof(struct permlist_node) );

  for(i=0; i<f; i++){
    perms[i].p = i;
    perms[i].visited = 0;
    perms[i].next = &perms[i+1];
    perms[i].prev = &perms[i-1];
  }
  perms[f-1].next = 0;
  pl = malloc(sizeof(struct permlist_node));
  pl->next = &perms[0];
  pl->p = -1;
  perms[0].prev = pl;

  pln = pl;
  while(pln){
    pln = pln->next;
  }
  
  printf("%d\n", count_configs());

  free(perms);
  free(pl);
  for(i=0; i<n; i++)
    free(edges[i]);
  free(edges);
  return 0;
}

void printArray(int n, int *a){
  int i;
  for(i=0; i<n; i++){
    printf("%d ", a[i]);
  }

}

int doDFS(struct permlist_node *pl){
  int a[n];
  int i, tmp, p;
  int num = 1;
  perm_from_int(n, pl->p, a);

  pl->visited = 1;
  pl->prev->next = pl->next;
  if(pl->next != 0)
    pl->next->prev = pl->prev;

  for(i=0; i<n-1; i++){
    if(!edges[a[i]][a[i+1]]){
      tmp = a[i];
      a[i] = a[i+1];
      a[i+1] = tmp;
      if(a[0] != 1){
	put1First(n, a);
      }
      p = perm_to_int(n, a);
      if(perms[p].visited == 0){
       	num += doDFS(&perms[p]);
      }
      if(i != 0){
	tmp = a[i];
	a[i] = a[i+1];
	a[i+1] = tmp;
      }
      else{
	tmp = a[0];
	a[0] = a[n-1];
	a[n-1] = tmp;
      }
      if(a[0] != 1)
	put1First(n, a);
    }
  }
  
  if(!edges[a[n-1]][a[0]]){
    tmp = a[0];
    a[0] = a[n-1];
    a[n-1] = tmp;
    put1First(n, a);
    p = perm_to_int(n, a);
    if(perms[p].visited == 0)
      num += doDFS(&perms[p]);
  }
  return num;
}

int count_configs(){
  int i=0;
  int a[n];
  while(pl->next != 0){
    printf("distinct: ");
    perm_from_int(n, pl->next->p, a);
    printArray(n, a);
    if(pl->next->visited)
      printf("Error!!!!!!!!!!!!!!!\n");
    printf(":%d\n", doDFS(pl->next));
    i++;
  }

  return i;
}

void put1First(int n, int *s){
  int i,tmp;
  while(s[0] != 1){
    tmp = s[0];
    for(i = 0; i<n; i++){
      s[i] = s[i+1];
    }
    s[n-1] = tmp;
  }

}

